﻿using Falcon.StoredProcedureRunner;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

namespace ReportService.Database
{
    /// <summary>
    /// 数据上下文工厂服务集合扩展
    /// </summary>
    public static class DbContextFactoryServiceCollectionEx
    {
        /// <summary>
        /// 注册数据库工厂
        /// </summary>
        /// <param name="services">服务集合</param>
        /// <param name="sectionKey">配置文件节点</param>
        /// <returns>服务集合</returns>
        public static IServiceCollection AddDbContextFactory(this IServiceCollection services,string sectionKey) {
            services.AddSingleton(sp => {
                var section = sp.GetService<IConfiguration>().GetSection(sectionKey);
                var runner = sp.GetService<IRunner>();
                return new DbContextFactory(section,runner);
            });
            return services;
        }
    }
}
