﻿
var myjs = {
    urls: {
        files: "/api/ReportApi/getreportfiles",
        reportList: "/api/ReportApi/GetReportList",
        fileContentUrl: "/api/ReportApi/GetHtml",
        reportUrl: "/api/ReportApi/GetPrint",
        getresult: "/api/ReportApi/GetResult",
        getData: "/api/ReportApi/GetData",
        GetServerTime: "/api/ReportApi/GetServerTime",
    },
    //定义从对象获取请求参数的方法
    getParaStr(data) {
        var arr = []
        for (const key in data) {
            arr.push(key + "=" + data[key])
        }
        return arr.join('&')
    },
    //创建sql字符串
    createSql(e) {
        var pn = "";
        var paras = "";
        var ec = $(e).find("input,select,textarea");
        for (var i = 0; i < ec.length; i++) {
            var e = $(ec[i]);
            var n = e.attr("name");
            var v = e.val();
            if (n == "ProcedureName") {
                pn = v;
            } else if (n == "reportName" || n == "sqlStr") {

            } else {
                paras = paras + " @" + n + "='" + v + "',";
            }
        }
        return "exec " + pn + paras.substring(0, paras.lastIndexOf(','));;
    },
    //发送post请求，发送data数据，执行成功方法sc和失败方法ec
    post(url, data, sc, ec) {
        if (!ec) {
            ec = function (e) {
                debugger;
                console.log(e);
                alert(e);
            };
        }
        fetch(url, {
            credentials: 'same-origin',
            method: 'POST', // or 'PUT'
            body: this.getParaStr(data),
            headers: new Headers({
                'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
            })
        })
            .then(Response => Response.json())
            .then(sc)
            .catch(ec);
    },
    //从数据库获取数据。
    getData(dbName, sql, sc, ec) {
        if (!ec) {
            ec = function (e) {
                console.log(e);
                alert(e);
            };
        }
        if (!sc) {
            sc = function (d) { console.log(d); };
        }
        var url = this.urls.getData;
        var rd = { DbName: dbName, Sql: sql, };
        fetch(url, {
            method: 'POST',
            body: JSON.stringify(rd),
            headers: new Headers({
                'Content-Type': 'application/json'
            })
        }).then(res => res.json()).catch(ec).then(sc);
    },
    //提示消息并记录
    showmsg(msg) {
        console.log(msg);
        alert(msg);
    },
    getUId() {
        return JSON.parse($.cookie("_userCK")).uid;
    },
    getUName() {
        return JSON.parse($.cookie("_userCK")).un;
    },
    print() {
        var pName = $("input[name='reportName']").val();
        var sqlStr = $("input[name='sqlStr']").val();
        $.cookie("_reportName", pName);
        $.cookie("_SqlString", sqlStr);
        window.open(this.urls.reportUrl + "?fileName=" + pName);
    },
    getReportName() {
        return $.cookie("_reportName");
    },
    getSqlStr() {
        return $.cookie("_SqlString");
    },
    GetServerTime(format, callback) {
        this.post(this.urls.GetServerTime, { format: format }, function (r) {
            callback(r.str);
        });
    },
    toExcel: {
        uri: 'data:application/vnd.ms-excel;base64,',
        template: '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel"' +
            'xmlns="http://www.w3.org/TR/REC-html40"><head><meta charset="UTF-8"><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet>'
            + '<x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets>'
            + '</x:ExcelWorkbook></xml><![endif]-->' +
            ' <style type="text/css">' +
            'table td {' +
            'border: 1px solid #000000;' +
            'width: 200px;' +
            'height: 30px;' +
            ' text-align: center;' +
            ' }' +
            '</style>' +
            '</head><body ><table class="excelTable">{table}</table></body></html>',
        base64(s) {
            return window.btoa(unescape(encodeURIComponent(s)));
        },
        format(s, c) {
            return s.replace(/{(\w+)}/g,
                function (m, p) {
                    return c[p];
                });
        },
        tableToExcel(tableid, sheetName) {
            if (!tableid.nodeType) tableid = document.getElementById(tableid);
            var ctx = { worksheet: sheetName || 'Worksheet', table: tableid.innerHTML };
            window.open(this.uri + this.base64(this.format(this.template, ctx)));
        },
    },

    getUrlKey: function (name) {
        return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.href) || [, ""])[1].replace(/\+/g, '%20')) || null
    },
    runSql: function (sqlStr, success) {
        var option = {
            method: "post",
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify({ sql: sqlStr, })
        };
        fetch("/RunSql", option)
            .then(function (res) { return res.json(); })
            .then(function (d) { success(d) })
            .catch(function (r) { });
    },
    formatTimeToStr: function (times, pattern) {
        if (times == null || times == "") {
            return "";
        }
        if (pattern) {
            var d = new Date(times).Format(pattern);
        } else {
            var d = new Date(times).Format("yyyy-MM-dd hh:mm:ss");
        }
        return d.toLocaleString();
    },
};